{
   OpenArena Name Changer (oanc)
   Copyright (c) 2011. Dejan Boras

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

   Started On:    01.03.2011.
   Last Update:   18.04.2011.
}

{$MODE OBJFPC}{$H+}

{$IFDEF RELEASE}
{$IFDEF WINDOWS}{$APPTYPE GUI}{$ENDIF}
{$ENDIF}
PROGRAM oanc;

USES
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, Resource, // this includes the LCL widgetset
  Forms, frmuMain, frmuAbout, frmuFav,
  {uoanc}
  uoanc, frmuCfg, frmuModSelect, frmuPreview, frmuHelp, frmuTextView, umod;

{$R *.res}

BEGIN
   Application.Title:='OpenArena Name Changer';
   InitializeConfig();

   {initialize}
   Application.Initialize();

   {create forms}
   Application.CreateForm(TfrmMain, frmMain);
   Application.CreateForm(TfrmAbout, frmAbout);
   Application.CreateForm(TfrmFav, frmFav);
   Application.CreateForm(TfrmCfg, frmCfg);
   Application.CreateForm(TfrmModSelect, frmModSelect);
   Application.CreateForm(TfrmPreview, frmPreview);

   {load configuration}
   LoadConfig();

   {apply window properties loaded from config}
   ApplyWndProps(favWndProps, frmFav);
   ApplyWndProps(mainWndProps, frmMain);
   ApplyWndProps(modSelectWndProps, frmModSelect);
   ApplyWndProps(cfgWndProps, frmCfg);

   {check OA configuration}
   oaCheckConfig(false);

   {load the OA configuration file}
   oaDefaultName := oaConfigLoad(oaCFG_BASE_NAME);
   PlayerName := oaDefaultName;

   {prepare images}
   if(LoadImages()) then
      CreateCharSelectImage()
   else
      exit();

   {run the application}
   frmMain.edName.Text := loadedname;
   Application.CreateForm(TfrmHelp, frmHelp);
   Application.CreateForm(TfrmTextView, frmTextView);
   Application.Run();

   {done, save settings}
   StoreWndProps(favWndProps, frmFav);
   StoreWndProps(mainWndProps, frmMain);
   StoreWndProps(modSelectWndProps, frmModSelect);
   StoreWndProps(cfgWndProps, frmCfg);

   SaveConfig();
END.

